ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
local id = -1
local entsAlive = 0

function ents.Startup()
	register["player"] = love.filesystem.load( ents.objpath .. "player.lua" )
	register["object"] = love.filesystem.load( ents.objpath .. "object.lua" )
	register["trail"] = love.filesystem.load( ents.objpath .. "trail.lua" )
end

function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )()
end

function ents.Create(name, x, y)
	x = x or 0
	y = y or 0
	if not fx then fx = false end
	if register[name] then
		id = id + 1
		entsAlive = entsAlive + 1
		local ent = register[name]()
		ent:load()
		ent.type = name
		ent:setPos(x, y)
		ent:setSize(size)
		ent.id = id
		ent.fx = fx
		ents.objects[id] = ent
		return ents.objects[id]
	else
		print("Error: Entity" .. name .. "does not exist.")
		return false;
	end
end

function ents.remove(id)
	if ents.objects[id] then
		if ents.objects[id].dead then
			ents.objects[id]:dead()
		end
		ents.objects[id] = nil
		entsAlive = entsAlive - 1
	end
end

function ents.getAlive()
	return entsAlive
end

function ents.update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents.draw()
	for i, ent in pairs(ents.objects) do
		if ent.fx then
			if ent.draw then
				ent:draw()
			end
		end
	end
	for i, ent in pairs(ents.objects) do
		if not ent.fx then
			if ent.draw then
				ent:draw()
			end
		end
	end
end

function ents.hit( x, y, w, h, id )
	for i, ent in pairs(ents.objects) do
		if ent.dead then
			if ent.type == "object" then
				local hit = CheckCollision( x, y, w, h, ent.x, ent.y, ent:getHitboxSize(), ent:getHitboxSize() )
				if hit then
					ents.remove(ent.id)
					score = score + 50*ent:getMultiplier()
					combo = combo + 1
					PlaySound()
					startFX( ent.x + 512*(ent.size/20), ent.y + 128*(ent.size/20), 1 )
				end
			end
		end
	end
end