local ent = ents.Derive("base")

function ent:setPos( x, y )
	self.x = x
	self.y = y
end

function ent:setSize( size )
	self.size = 128
end

function ent:load( x, y )
	self:setPos( x, y )
	self.image = love.graphics.newImage ( "assets/images/player.png" )
	width, height = self.image:getDimensions()
	Timer.every(0.01, function()
		if love.keyboard.isDown("lshift") then
			ents.Create("trail", self.x, self.y) 
		end
	end)
end

function ent:update(dt)
	local left	= love.keyboard.isDown("left")
	local right	= love.keyboard.isDown("right")
	local dash	= love.keyboard.isDown("lshift")
	if dash then
		speed = 100
	else
		speed = 50
	end
	if left then
		self.x = self.x - speed*dt
	elseif right then
		self.x = self.x + speed*dt
	elseif left and right then 
		self.x = self.x
	end
	--
	if self.x <= bounds.x1+(self.size*0.5) then self.x = bounds.x1+(self.size*0.5) end
	if self.x >= bounds.x2-(self.size*0.5) then self.x = bounds.x2-(self.size*0.5) end
	--
	ents.hit(self.x-16, self.y-16, self.size, 1)
end

function ent:draw()
	love.graphics.draw( self.image, self.x, self.y, 0, 1, 1, width/2, height/2 )
end

return ent;