Timer		= require "lib.timer"
Gamestate	= require "lib.gamestate"
Venus		= require "lib.venus"
TESound		= require "lib.tesound"

ScrW, ScrH = love.graphics.getDimensions( )

function love.load()
	require ( "entities" )
	require ( "playfield" )
	require ( "notify" )
	require ( "timebar" )
	require ( "entities.glow" )
	
	require ( "menu" )
	require ( "game" )
	require ( "results" )
	
	bg = love.graphics.newImage( "assets/images/background.png" )
	numFont = love.graphics.newImageFont("assets/images/numbers.png", "0123456789x")
	sources = {love.audio.newSource("assets/sounds/hit.wav", "static")}
	defaultFont = love.graphics.setNewFont("assets/Aller.ttf",12)
	creditsFont = love.graphics.setNewFont("assets/Aller.ttf",16)
	ents.Startup()
    Venus.registerEvents()
    Venus.switch(menu)
end

function love.draw()
end

function love.update(dt)
	Timer.update(dt)
	TEsound.cleanup()
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
end

function CheckCollision(x1,y1,w1,h1,x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function PlaySound()
    -- Try to find a stopped Source in our list, and play it if we find one.
    for i, source in ipairs(sources) do
        if source:isStopped() then
            source:play()
            return
        end
    end

    -- If there are no stopped Sources, create a new one and add it to the list.
    local source = sources[1]:clone()
    table.insert(sources, source)
    source:play()
end